Subject: Re: next-20081119: general protection fault: get_next_timer_interrupt()

From: [email-masked]
Date: Tue, 25 Nov 2008 08:59:55 -0800

Jens Axboe [[email-masked]] wrote:
> On Mon, Nov 24 2008, [email-masked] wrote:
> > Stephen Rothwell [[email-masked]] wrote:
> > > > The block timer code calls del_timer(), should it call del_timer_sync()?
> > > > It is possible although unlikely that you are hitting del_timer_sync vs
> > > > del_timer problem in the block timeout code. Can only be seen on SMP
> > > > systems though!
> > > 
> > > Is this still a problem in next-20081121? In that tree, the block commit
> > > "block: leave the request timeout timer running even on an empty list"
> > > was changed to add this:
> > > 
> > > diff --git a/block/blk-core.c b/block/blk-core.c
> > > index 04267d6..44f547c 100644
> > > --- a/block/blk-core.c
> > > +++ b/block/blk-core.c
> > > @@ -391,6 +391,7 @@ EXPORT_SYMBOL(blk_stop_queue);
> > >  void blk_sync_queue(struct request_queue *q)
> > >  {
> > >  	del_timer_sync(&q->unplug_timer);
> > > +	del_timer_sync(&q->timeout);
> > >  	kblockd_flush_work(&q->unplug_work);
> > >  }
> > >  EXPORT_SYMBOL(blk_sync_queue);
> > 
> > I was looking at the Linux tree. Clearly same problem doesn't exist with
> > the above commit! I wonder why kblockd_flush_work() is called after the
> > del_timer_sync(). It makes sense to cancel the work and then shutdown
> > the timer(s). I doubt if you are running into this problem though.
> 
> If the kernel tested doesn't include the above fix, it'll surely go
> boom. Can someone verify that this is the case?

Just looked, next-20081119 doesn't have the above fix. It is included in
next-20081120. Also note that the above fix is only partially copied,
there is other part that removed deleting the timer when there are no
outstanding requests.

--Malahal.